.MODEL  medium
.CODE



PUBLIC  	_readkey,_replace,_putback,_newkeyrt,_initkey
PUBLIC   _initcrit,_critErr,_readcrit,_critclear
PUBLIC	_setscancodes




INTTAB  SEGMENT AT 0H
	ORG 9H*4
KBADDR  LABEL   DWORD
INTTAB  ENDS


_replace	PROC

		push    bp
		mov     bp,sp
		push    ax
		push    ds

		jmp     past
KBSAVE          DD      ?

past:
		cli
		assume  ds:INTTAB
		mov     ax,INTTAB
		mov     ds,ax
		mov     ax,WORD PTR KBADDR
		mov     WORD PTR KBSAVE,ax

		mov     ax,WORD PTR KBADDR+2
		mov     WORD PTR KBSAVE+2,ax

		mov     WORD PTR KBADDR,OFFSET _newkeyrt
		mov     WORD PTR KBADDR+2,cs
		sti

		pop     ds
		pop     ax
		pop     bp
		ret
_replace        ENDP


_newkeyrt          PROC



		push		ax
		push     bx
		push		cx
		push		ds
		push		es
		push		di
		push		si


		jmp     past2
;up,down,left,right,b1,b2,b3,v2butt1,escape,q,start2,start1,coin 1
vup            DB   	?
vdown          DB   	?
vleft          DB   	?
vright         DB   	?
vbutt1         DB   	?
vbutt2         DB   	?
vbutt3         DB   	?
vlock				DB		?
v2butt1			DB		?
vescape        DB   	?
vstart2			DB		?
vstart1			DB		?
vcoin1			DB		?

;the scancodes

sup            DB   	?
sdown          DB   	?
sleft          DB   	?
sright         DB   	?
sbutt1         DB   	?
sbutt2         DB   	?
sbutt3         DB   	?
slock				DB		?
s2butt1			DB		?
sescape        DB   	?
sstart2			DB		?
sstart1			DB		?
scoin1			DB		?


past2:

;read the keyboard port
		in    al,60h
;save it
		push	ax

		in		al,61h
		mov	ah,al
		or		al,82h
		out	61h,al
		mov	al,ah
		and	al,7fh
		out	61h,al
;get the keycode back
		pop	ax

		mov   ah,al
;get the scancode
		and   al,127
;and the make/break state
		and	ah,128
;invert make/break to make life easier
		xor	ah,128

;now check all the keys

		mov		bx,cs
		mov		es,bx
		mov		ds,bx
		mov		si,offset vup
		mov		di,offset sup
		mov		cx,13

chklp:
		cmp		al,es:[di]
		jne		nomatch
		mov		ds:[si],ah
nomatch:
		inc		si
		inc		di
		loop		chklp






		mov	al,20h
		out	20h,al




		pop		si
		pop		di
		pop		es
		pop		ds
		pop		cx
		pop		bx
		pop		ax
		iret



_newkeyrt          ENDP


_putback        PROC

		push    bp
		mov     bp,sp

		push    ds
		push    ax

		cli
		assume  ds:INTTAB
		mov     ax,INTTAB
		mov     ds,ax

		mov     ax,cs:WORD PTR KBSAVE
		mov     ds:WORD PTR KBADDR,ax
		mov     ax,cs:WORD PTR KBSAVE+2
		mov     ds:WORD PTR KBADDR+2,ax

		sti


		pop     ax
		pop     ds
		pop     bp
		ret
_putback        ENDP


_setscancodes	PROC
		ARG		scanptr:DWORD

		push    	bp
		mov     	bp,sp
		push    	es
		push    	ds
		push    	di
		push    	si
		push    	ax

		mov     	ax, cs

		mov     	es, ax
		mov	  	di,OFFSET sup
		lds	  	si,scanptr


;copy across scancodes for
;up,down,left,right,b1,b2,b3,lock(l),2plybt1,escape,2,1,3
		mov     	cx,13
		cld
		rep     	movsb


		pop     	ax
		pop     	si
		pop     	di
		pop     	ds
		pop     	es
		pop     	bp
		ret
_setscancodes	ENDP


_readkey        PROC
		ARG     keyptr:DWORD

		push    bp
		mov     bp,sp
		push    es
		push    ds
		push    di
		push    si
		push    ax

		mov     ax, cs
		mov     ds, ax
		mov	  si,OFFSET vup
		les     di, keyptr
;copy across
;up,down,left,right,b1,b2,b3,lock(l),2plybt1,escape,2,1,3
		mov     cx,13
		cld
		rep     movsb

		pop     ax
		pop     si
		pop     di
		pop     ds
		pop     es
		pop     bp
		ret

_readkey        ENDP


_initkey        PROC
		push   	bp
		mov     	bp,sp
		push		ax
		push		cx
		push		es
		push		di


		mov		ax,cs
		mov		es,ax
		mov		di,offset vup

		xor		ax,ax
		mov		cx,13
		cld
		rep		stosb


		pop		di
		pop		es
		pop		cx
		pop		ax
		pop     	bp
		ret
_initkey        ENDP



_initcrit		PROC
		push   	bp
		mov     	bp,sp
		push		ax
		push		dx

		mov		al,24h
;put code seg into data seg
		push		ds
		push		cs
		pop		ds
;put in our critical error handler
		mov		dx,OFFSET _critErr
		mov		ah,25h
		int		21h
;put data seg back again
		pop		ds

		pop		dx
		pop		ax
		pop		bp
		ret
_initcrit		ENDP


_critErr			PROC

		mov		al,3
		mov		cs:berr,al

		iret
_critErr			ENDP

_critclear		PROC
		push		bp
		mov		bp,sp
		push		ax


		jmp     	pastc1
berr           DB   	?
pastc1:
		xor		al,al
		mov		cs:berr,al

		pop		ax
		pop		bp
		ret
_critclear		ENDP

_readcrit      PROC
		ARG     	errptr:DWORD

		push    	bp
		mov    	bp,sp
		push    	es
		push    	ds
		push    	di
		push    	si
		push    	ax

		mov     	ax,cs
		mov     	ds,ax
		mov	  	si,OFFSET berr
		les     	di,errptr
		mov		al,ds:[si]
		mov		es:[di],al

		pop     	ax
		pop     	si
		pop     	di
		pop     	ds
		pop     	es
		pop     	bp
		ret

_readcrit        ENDP


		END
