; Assembler functions for VGA


.MODEL  small
.CODE


PUBLIC   _readregs,_setgmode




_setgmode       PROC
		ARG             mode:BYTE
		push	bp
		mov   bp,sp
		mov   al,[mode]
		xor   ah,ah
		int   10h
		pop   bp
		ret
_setgmode       ENDP



_readregs  	PROC
	ARG     	keyptr:DWORD
	push		bp
	mov		bp,sp
	push		ax
	push		bx
	push		cx
	push		dx
	push		es
	push		di

	les		di,keyptr
;misc output register
	mov		dx,3cch
	in			al,dx
	stosb


;the first 10 (0-9) CRTC registers
	mov   	cx,10
	xor		bl,bl
	mov		dx,3d4h
crtc1:
	mov		al,bl
	out		dx,al
	inc		dx
	in			al,dx
	stosb
	dec		dx
	inc		bl
	loop		crtc1


;crtc registers 16 - 24
	mov		cx,8
	mov		bl,10h
crtc2:
	mov		al,bl
	out		dx,al
	inc		dx
	in			al,dx
	stosb
	dec		dx
	inc		bl
	loop		crtc2



;the sequencer registers

	mov	dx,3c4h
	mov	al,1
	out	dx,al
	inc	dx
	in		al,dx
	stosb
	dec	dx


	mov	al,4
	out	dx,al
	inc	dx
	in		al,dx
	stosb
	dec	dx



;graphics controller registers
	mov	dx,3ceh
	mov	al,5
	out	dx,al
	inc	dx
	in		al,dx
	stosb
	dec	dx

	mov	al,6
	out	dx,al
	inc	dx
	in		al,dx
	stosb
	dec	dx

;attribute address registers
	mov	dx,3dah
	in		al,dx

	mov	al,10h
	or		al,32

	mov	dx,3c0h
	out	dx,al
	mov	cx,4000
del1:
	inc	al
	loop	del1

	inc	dx
	in		al,dx
	stosb



	mov	dx,3dah
	in		al,dx

	mov	al,13h
	or		al,32

	mov	dx,3c0h
	out	dx,al
	mov	cx,4000
del2:
	inc	al
	loop	del2

	inc	dx
	in		al,dx
	stosb

done:


	pop		di
	pop		es
	pop		dx
	pop		cx
	pop		bx
	pop		ax
	pop		bp
	ret


_readregs	ENDP



		END
